package dk.sosi.sts.nemlogin.uuid2cpr;

import dk.nemlog_in.lookupservice.LookupService;
import org.junit.Before;
import org.junit.Test;

import static org.junit.Assert.*;

public class LookupServiceObjectFactoryTest {
    private LookupServiceObjectFactory subject;

    @Before
    public void setup() {
        Uuid2CprProperties properties = new Uuid2CprProperties();

        properties.setAppliesTo("https://saml.wsp.lookupservice.devtest4-nemlog-in.dk");
        properties.setSignatureUsername("lookup");
        properties.setSignaturePassword("Test1234");
        properties.setSignaturePropertiesFile("client.properties");
        properties.setEncryptionUsername("sts");
        properties.setEncryptionPropertiesFile("sts.properties");
        properties.setLookupServiceUrl("https://lookupservice.devtest4-nemlog-in.dk/LookupService.svc");
        properties.setSecurityTokenServiceUrl("https://SecureTokenService.devtest4-nemlog-in.dk/SecurityTokenService.svc");

        subject = new LookupServiceObjectFactory(properties);
    }

    @Test
    public void makeObject_createsObject() {
        // Arrange

        // Act
        LookupService result = subject.makeObject();

        // Assert
        assertNotNull(result);
    }
}