package dk.nsp.uuid2cpr.proxy.health;

import java.util.Arrays;
import java.util.List;

public class HealthStatus {
    private boolean healthy;
    private List<String> messages;

    private HealthStatus(boolean healthy, List<String> messages) {
        this.healthy = healthy;
        this.messages = messages;
    }

    public static HealthStatus ok(String message) {
        return ok(Arrays.asList(message));
    }

    public static HealthStatus ok(List<String> messages) {
        return new HealthStatus(true, messages);
    }

    public static HealthStatus unhealthy(String message) {
        return unhealthy(Arrays.asList(message));
    }

    public static HealthStatus unhealthy(List<String> messages) {
        return new HealthStatus(false, messages);
    }

    public boolean isHealthy() {
        return healthy;
    }

    public List<String> getMessages() {
        return messages;
    }
}
