package dk.nsp.uuid2cpr.proxy.service;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.nio.charset.StandardCharsets;

public class OpenApiWriterImpl implements OpenApiWriter {
	private final String endpoint;

	public OpenApiWriterImpl(String endpoint) {
		this.endpoint = endpoint;
	}

	@Override
	public void writeOpenApi(HttpServletResponse response) throws IOException {
		ClassLoader cl = Thread.currentThread().getContextClassLoader();
		InputStream stream = cl.getResourceAsStream("uuid2cpr-proxy.yaml");
		if (stream == null) {
			response.setStatus(404);
			return;
		}

		PrintWriter writer = response.getWriter();
		try (BufferedReader reader = new BufferedReader(new InputStreamReader(stream, StandardCharsets.UTF_8))) {
			reader.lines()
				.map(x -> x.replace("%endpoint%", endpoint))
				.forEach(writer::println);
		}
	}
}
